// --------------------------------------------------------------- -*- JS -*-
// IBM Confidential
// OCO Source Materials
// 5724-Y00 5724-Y02
//  Copyright IBM Corp. 2004, 2010. All Rights Reserved.
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
// --------------------------------------------------------------------------

Ext.namespace('Ilog', 'Ilog.Constants');

Ilog.Constants.RuleEditorConstantsImpl = function() {
    // Toolbar preferences
    this.ToolbarUpdatePollInterval = 2500;
    this.ToolbarUpdateCheckDelay = 250;

    // Problem list
    this.ProblemListExpanded = 1;
    this.ProblemListCollapsed = 0;

    // AJAX requests management
    this.ServerReponseStatusSuccess = 0;
    this.ServerReponseStatusFailure = -1;
    this.ServerReponseStatusCacheMiss = -2;
    this.ServerReponseStatusDtCacheMiss = -3;
    this.CallbackStringRequestTypeRefreshEditor = 1;
    this.CallbackStringRequestTypeGetPredictions = 2;
    this.CallbackStringRequestTypeSaveRule = 3;
    this.CallbackStringRequestTypeNodeDescription = 4;
     this.CallbackStringRequestTypeGetValueEditor = 7;
    this.CallbackPredictionsDelay = 450;
    this.CallbackRefreshContentTextDelay = 450; // delay before server call is sent
    this.AjaxRetryCountBeforeCallbackHandler = 3;
    this.XmlHttpRequestTimeout = 15000; // nb of ms after which a XmlHttpRequest is considered as a timeout

    // Editor cleaning & optimization
    this.UseMouseUpGlobalEventToManageFocusOut = true;
    this.MouseUpGlobalScriptCheckInterval = 5000;
    this.CleanEditorResourcesDelay = 20; // mouseup global event
    this.GeckoIntervalForAutomaticRefreshCheck = 2500;
    this.MaxSizeOnPaste = 1000; // limitation on data length to be pasted in the editor
    this.EnableToolbarButtonsUpdate = true;

    // Editor key codes management
    this.CharKeyCodeForSaveShortcut = 83; // 83 = S
    this.CharKeyCodeForPredictions = 32; // 32 = space key
    this.UseAlternateCharKeyCodeForPredictions = false;
    this.AlternateCharKeyCodeForPredictions = Ext.EventObject.ENTER;
    this.CharKeyCodeForDtValidation = Ext.EventObject.ENTER;
    this.CharKeyCodeForDtCancellation = Ext.EventObject.ESC;
    this.CharForWordSeparator = ' ';
    this.KeycodeForWordSeparator = 160;
    this.CharForLineSeparator = '\n';
    this.KeycodeForLineSeparator = 10;
    this.CharForSemicolonSeparator = ';';
    this.KeycodeForSemicolonSeparator = 190;
    this.CharKeyCodeForSwitchToPredFilter = Ext.EventObject.DOWN;
    this.CharKeyCodeForSwitchToBuffer = Ext.EventObject.UP;
    this.ShiftModifierForSwitchToPredFilter = true;
    this.ShiftModifierForSwitchToBuffer = true;
    this.CharKeyCodeTabulation = 9;
    this.UseKeyboardShortCutForPlaceholderSelect = true;
    this.KeyDownEvent = 1;
    this.KeyUpEvent = 2;
    this.KeyPressEvent = 3;
    
    // Undo/redo stack preferences
    this.UndoRedoStackSize = 20;
    this.UndoRedoSaveDelay = 1500;

    // DOM node recognition patterns
    this.PatternValueEditorRecognition = 'ilogvalueeditor';
    this.PatternPlaceHolderRecognition = 'ilog-placeHolder';
    this.PatternPlaceHolderGroupRecognition = 'placeHolderId';
    this.PatternFrozenZoneRecognition = 'ilog-frozen';
    this.FrozenTextCssClass = 'ilog-ruleEditor-frozenText';

    // Tooltips management
    this.CallbackTooltipDelay = 1200;
    this.TooltipCssClass = 'ilog-tooltip';
    this.TooltipAttributeName = 'ilogtooltip';
    this.TooltipDelayBeforeDisplay = 700;
    this.TooltipsActivated = true;
    this.TooltipYmargin = 20;

    // Completion menu resources
    this.CompletionMinimumHeight = 90;
    this.CompletionDefaultWidth = 300;
    this.PredictionsFilteringDelay = 500;
    this.ContextValidatePrediction = 'ValidatePrediction';
    this.CloseCompletionMenuText = 'X';
    this.CaretBottomMargin = 16;
    this.TreenodeExpanded = 1;
    this.TreenodeCollapsed = 0;
    this.TreenodeDefaultStatus = this.TreenodeExpanded;
    this.IcVocabulary = 0;
    this.IcVocabularyDomain = this.IcVocabulary + 1;
    this.IcConcept = this.IcVocabularyDomain + 1;
    this.IcConceptInstance = this.IcConcept + 1;
    this.IcSentence = this.IcConceptInstance + 1;
    this.IcSentenceAction = this.IcSentence + 1;
    this.IcSentenceGetter = this.IcSentenceAction + 1;
    this.IcSentenceSetter = this.IcSentenceGetter + 1;
    this.IcSentenceOperator = this.IcSentenceSetter + 1;
    this.IcSentencePredicate = this.IcSentenceOperator + 1;
    this.IcVariable = this.IcSentencePredicate + 1;
    this.IcAutomaticVariable = this.IcVariable + 1;
    this.IcImplicitVariable = this.IcAutomaticVariable + 1;
    this.IcText = this.IcImplicitVariable + 1;
    this.IcValue = this.IcText + 1;
    this.IcEmpty = this.IcValue + 1;
    this.IcNamespace = this.IcEmpty + 1;
    this.IcFolder = this.IcNamespace + 1;
    this.PredictionPresentationModeFlat = 0;
    this.PredictionPresentationModeTreeview = 1;
    this.SearchDisabled = 0;
    this.SearchEnabled = 1;
    this.CssClassCompletionMenuTreeItemConcept = 'ilog-predictionsView-TreeviewItemConcept';
    this.CssClassCompletionMenuTreeItemNoConcept = 'ilog-predictionsView-TreeviewItemNoConcept';
    this.UsePagination = true;
    this.PaginationThreshold = 20;
    this.PageSize = 20;
    this.UseAdaptativeDelaysForFilter = true;
    this.AdaptativeDelaysRange1 = { max: 3, delay: 500 };
    this.AdaptativeDelaysRange2 = { min: 4, max: 7, delay: 300 };
    this.AdaptativeDelaysRange3 = { min: 8, delay: 200 };
    this.UseExtraDelayForLargeNbItems = true;
    this.LargeNbItems = 100;
    this.LargeNbItemsExtraDelay = 600;
    this.CssClassLinkToOtherPages = "ilog-predictionsView-LinkToOtherPages";
    this.CssClassLinkToOtherPagesSelected = "ilog-predictionsView-LinkToOtherPagesSelected";
    this.CssClassLinkToPage = "ilog-predictionsView-LinkToPage";
    this.CssClassLinkToPageSelected = "ilog-predictionsView-LinkToPageSelected";
    this.CssClassOtherPages = "ilog-predictionsView-OtherPages";
    this.CssClassCurrentPage = "ilog-predictionsView-CurrentPage";
    this.LinuxFFArrowFirstDelay = 200;
    this.LinuxFFArrowDelay = 80;
    this.SearchAreaMargin = 25;

    // built-in value editors references
    this.FullDateValueEditor = "ilog.rules.brl.ui.value.editor.IlrFullDateValueEditor";
    this.ShortDateValueEditor = "ilog.rules.brl.ui.value.editor.IlrShortDateValueEditor";
    this.UniversalDateValueEditor = "ilog.rules.brl.ui.value.editor.IlrUniversalDateValueEditor";
    this.Environment = 0; // impact date formats
    this.DelayCalendarValidation = 80;

    // Custom value editors modes
    this.FullScriptMode = 1;
    this.ReferenceScriptMode = 2;
    this.DisplayModal = 1;
    this.DisplayInline = 2;

    // Prediction concepts (treeview sorting)
    this.PredictionConceptValue = 2;
    this.PredictionConceptVariable = 4;
    this.PredictionConceptSentence = 8;
    this.PredictionConceptTarget = 16;

    // Fixes
    this.FfScrollFix = true;
    this.CharacterSquareSize = 40;
    this.ScrollMargin = 50;
    this.IEScrollFixHideLayerMargin = 3;
    this.IEScrollFixHideLayerDelay = 120;
    this.IECaretVisibleMargin = 20;

    // Clipboard settings
    this.FirefoxSetting0 = 'about:config';
    this.FirefoxSetting1 = 'signed.applets.codebase_principal_support';

    // Debugging
    this.DebuggerTextAreaMode = 0;
    this.DebuggerDivMode = 1;
    this.UseDebugger = false;
    this.DebuggerMode = this.DebuggerDivMode;
    this.DebuggerFieldId = 'IlogRuleEditorDebugger';
};

Ilog.Constants.RuleEditorConstants = new Ilog.Constants.RuleEditorConstantsImpl();
