// --------------------------------------------------------------- -*- JS -*-
// IBM Confidential
// OCO Source Materials
// 5724-Y00 5724-Y02
//  Copyright IBM Corp. 2004, 2010. All Rights Reserved.
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
// --------------------------------------------------------------------------

Ext.namespace('Ilog', 'Ilog.Debug');

Ilog.Debug.RuleEditorDebuggerImpl = function() {
    this.DebugField = document.getElementById(Ilog.Constants.RuleEditorConstants.DebuggerFieldId);

    this.GetTimestamp = function() {
        var curtime = new Date();
        var curhour = curtime.getHours(), curmin = curtime.getMinutes(), cursec = curtime.getSeconds();
        var timestamp = curhour + ":" + curmin + "'" + cursec;
        return timestamp;
    };

    this.PrintDebug = function(debugMessage) {
        try {
            if (!(Ilog.Constants.RuleEditorConstants.UseDebugger === true)) {
                return;
            }

            if (!this.DebugField || !debugMessage) {
                return;
            }

            var messageToPrint = debugMessage + '';
            messageToPrint = '[' + this.GetTimestamp() + '] ' + Ext.util.Format.htmlEncode(messageToPrint);

            if (Ilog.Constants.RuleEditorConstants.DebuggerMode == Ilog.Constants.RuleEditorConstants.DebuggerDivMode) {
                this.DebugField.innerHTML = this.DebugField.innerHTML + '<br/>' + messageToPrint;

                if (this.DebugField.scrollHeight) {
                    this.DebugField.scrollTop = this.DebugField.scrollHeight;
                }
            }
            else {
                this.DebugField.value = this.DebugField.value + '\n' + messageToPrint;
                this.DebugField.scrollTop = this.DebugField.scrollHeight;
            }
        }
        catch (ex) { }
    };
};

Ext.onReady(function() { if (!Ilog.Debug.RuleEditorDebugger) { Ilog.Debug.RuleEditorDebugger = new Ilog.Debug.RuleEditorDebuggerImpl(); } }, window);