// --------------------------------------------------------------- -*- JS -*-
// IBM Confidential
// OCO Source Materials
// 5724-Y00 5724-Y02
//  Copyright IBM Corp. 2004, 2010. All Rights Reserved.
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
// --------------------------------------------------------------------------

Ext.namespace('Ilog', 'Ilog.ProblemList');

// Expandable list constructor
Ilog.ExpandableList = function(expListPanelIdentifier, isExpanded, cssClassExpanded, cssClassColapsed){
    this.ExpListPanelIdentifier = expListPanelIdentifier;
    this.ExpListPanel = document.getElementById(expListPanelIdentifier);
    this.IsExpanded = isExpanded;
    this.CssClassExpanded = cssClassExpanded;
    this.CssClassColapsed = cssClassColapsed;
};

Ilog.ExpandableList.prototype = {
    // Expand the list
    Expand: function() {
        if (this.ExpListPanel != null) {
            this.ExpListPanel.className = this.CssClassExpanded;
            this.IsExpanded = true;
        }
    },

    // Collapse
    Collapse: function() {
        if (this.ExpListPanel != null) {
            this.ExpListPanel.className = this.CssClassColapsed;
            this.IsExpanded = false;
        }
    },

    // Collapse or expand on click
    HandleClick: function() {
        if (this.IsExpanded) {
            this.Collapse();
            return Ilog.Constants.RuleEditorConstants.ProblemListCollapsed;
        }
        else {
            return this.Expand();
            return Ilog.Constants.RuleEditorConstants.ProblemListExpanded;
        }
    }
};
