// --------------------------------------------------------------- -*- JS -*-
// IBM Confidential
// OCO Source Materials
// 5724-Y00 5724-Y02
//  Copyright IBM Corp. 2004, 2010. All Rights Reserved.
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
// --------------------------------------------------------------------------

(function () {
    // Browser identification
	var isGecko	= ( navigator.product === 'Gecko' );
	var isIE = window.document.all && !window.opera;

	// Saving previous XHR object if available
	var currentXHRImpl	= window.XMLHttpRequest;
    
	// ctor
	function XHRImpl() {
		this._impl = currentXHRImpl ? new currentXHRImpl : new window.ActiveXObject('Microsoft.XMLHTTP');
	};
	
	XHRImpl.UNSENT = 0;
	XHRImpl.OPENED = 1;
	XHRImpl.HEADERS_RECEIVED = 2;
	XHRImpl.LOADING = 3;
	XHRImpl.DONE = 4;

	XHRImpl.prototype.readyState = XHRImpl.UNSENT;
	XHRImpl.prototype.responseText = "";
	XHRImpl.prototype.responseXML = null;
	XHRImpl.prototype.status = 0;
	XHRImpl.prototype.statusText = "";

	XHRImpl.prototype.onreadystatechange = null;
	XHRImpl.onreadystatechange = null;
	XHRImpl.onopen = null;
	XHRImpl.onsend = null;
	XHRImpl.onabort = null;

    // overcome FireBug bug
    try{
        if ( currentXHRImpl.wrapped && isGecko ){
	        XHRImpl.wrapped	= currentXHRImpl.wrapped;
        }
    }
    catch(ex){}

    XHRImpl.prototype.notifyTimeout	= function(){
    }
        
	XHRImpl.prototype.open	= function(httpMethod, url, async, user, pwd) {
		var state = this.readyState;
        var request = this;
        this._async	= async;

        // IE fix
		if ( isIE ) {
			var unloadFct = function() {
				if ( request._impl.readyState != XHRImpl.DONE ){
					clean(request);
                }
			};
			
			if ( async ){
				window.attachEvent("onunload", unloadFct);
            }
		}

		this._impl.onreadystatechange	= function() {
			if ( isGecko && !async ){
				return;
            }

			request.readyState = request._impl.readyState;
			sync(request);

			// fix FF
			if (request._aborted) {
				request.readyState	= XHRImpl.UNSENT;
				return;
			}

			if (request.readyState == XHRImpl.DONE) {
				clean(request);

				// fix IE
				if ( !request._impl.getResponseHeader("Date") ) {
					request._cached	= request._impl;
					XHRImpl.call(request);
					request._impl.open(httpMethod, url, async, user, pwd);
					request._impl.setRequestHeader("If-Modified-Since", request._cached.getResponseHeader("Last-Modified") || new window.Date(0));

					if (request._headers)
						for (var header in request._headers){
							if ( typeof request._headers[header] == "string" ){
								request._impl.setRequestHeader(header, request._headers[header]);
							}
                        }
                    

					request._impl.onreadystatechange	= function() {
						request.readyState = request._impl.readyState;

						if ( request._aborted ) {
							request.readyState	= XHRImpl.UNSENT;
							return;
						}

						if (request.readyState == XHRImpl.DONE) {
							clean(request);
							if ( request.status == 304 ){
								request._impl	= request._cached;
							}

							delete request._cached;
							sync(request);
							readyStateChange(request);

							// fix IE
							if ( isIE && async ){
								window.detachEvent("onunload", unloadFct);
                            }
						}
					};
					
					try{
    					request._impl.send(null);
					}
					catch(ex){}
					return;
				};

				if ( isIE && async ){
				    try {
					    window.detachEvent("onunload", unloadFct);
					}
					catch(ex){}
			    }
			}

			if ( state != request.readyState ){
				readyStateChange(request);
            }

			state = request.readyState;
		};
        
		if (XHRImpl.onopen ){
			XHRImpl.onopen.apply(this, arguments);
		}
			                           
		this._impl.open(httpMethod, url, async, user, pwd);

		if ( !async && isGecko ) {
			this.readyState	= XHRImpl.OPENED;
			readyStateChange(this);
		}
	};
	
	XHRImpl.prototype.send	= function(data) {
		if ( XHRImpl.onsend ){
			XHRImpl.onsend.apply(this, arguments);
        }

		if (data && data.nodeType ) {
			data = window.XMLSerializer ? new window.XMLSerializer().serializeToString(data) : data.xml;
			if ( !this._headers["Content-Type"] ){
				this._impl.setRequestHeader("Content-Type", "application/xml");
            }
		}
		try{
		    this._impl.send(data);
        }
        catch(ex){}
        
		if ( isGecko && !this._async ) {
			this.readyState	= XHRImpl.OPENED;
			sync(this);

			while (this.readyState < XHRImpl.DONE) {
				this.readyState++;
				readyStateChange(this);
				if ( this._aborted ){
					return;
                }
			}
		}
	};
	
	XHRImpl.prototype.abort	= function() {
		if ( XHRImpl.onabort ){
			XHRImpl.onabort.apply(this, arguments);
        }
		
		if ( this.readyState > XHRImpl.UNSENT ){
			this._aborted	= true;
        }
        
        this._impl.onreadystatechange	= function() {}
		this._impl.abort();
		clean(this);
	};
	
	XHRImpl.prototype.getAllResponseHeaders	= function() {
		return this._impl.getAllResponseHeaders();
	};
	
	XHRImpl.prototype.getResponseHeader	= function(name) {
		return this._impl.getResponseHeader(name);
	};
	
	XHRImpl.prototype.setRequestHeader	= function(name, value) {
		if ( !this._headers ){
			this._headers = {};
        }
		this._headers[name]	= value;
		return this._impl.setRequestHeader(name, value);
	};
	
	XHRImpl.prototype.toString	= function() {
		return '[' + "object" + ' ' + "XMLHttpRequest" + ']';
	};
	
	XHRImpl.toString	= function() {
		return '[' + "XMLHttpRequest" + ']';
	};

	function readyStateChange(request) {
		if ( request.onreadystatechange ){
			request.onreadystatechange.apply(request);
		}
		
		if (XHRImpl.onreadystatechange){
			XHRImpl.onreadystatechange.apply(request);
        }
	};

	function getXmlResponse(request) {
		var xmlResp	= request.responseXML;

		if ( isIE && xmlResp && !xmlResp.documentElement && request.getResponseHeader("Content-Type").match(/[^\/]+\/[^\+]+\+xml/) ) {
			xmlResp	= new ActiveXObject('Microsoft.XMLDOM');
			xmlResp.loadXML(request.responseText);
		}

		if (xmlResp){
			if ((isIE && xmlResp.parseError != 0) || (xmlResp.documentElement && xmlResp.documentElement.tagName == "parsererror")){
				return null;
            }
        }
        
		return xmlResp;
	};

	function sync(request) {
		try {	request.responseText = request._impl.responseText; } catch (e) {}
		try {	request.responseXML	= getXmlResponse(request._impl); } catch (e) {}
		try {	request.status = request._impl.status; } catch (e) {}
		try {	request.statusText = request._impl.statusText; } catch (e) {}
	};

	function clean(request) {
		request._impl.onreadystatechange = new window.Function;
		delete request._headers;
	};

    // adding apply fct if not available
	if ( ! window.Function.prototype.apply ) {
        window.Function.prototype.apply	= function(request, args) {
			if ( !args ){
				args = [];
            }
			request.__func	= this;
			request.__func(args[0], args[1], args[2], args[3], args[4]);
			delete request.__func;
		};
	};

	// Register new object with window
	window.XMLHttpRequest	= XHRImpl;
})();
