// --------------------------------------------------------------- -- JS --
// IBM Confidential     
// OCO Source Materials  
// 5724-Y00 
//  Copyrights by IBM Corp 1987, 2010. - All rights Reserved
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
// --------------------------------------------------------------------------

/**
 * Specific textfield for DT editor
 * This component allows validation of every keyboard input in the text field
 */
function IlrDTWTextField(port, id, onChangeAction, emptyText, choices, dhtml, labelId, textId, onKeyPressAction) {
  this.base = IlxWTextField;
  this.base(port, id, onChangeAction, emptyText, choices, dhtml, labelId, textId);
  // on key press for validation
  this.onKeyPress = IlrDTWTextField_onKeyPress;
  this.onKeyPressAction = onKeyPressAction;
  // on key up for tracking key by key input
  this.onKeyUp = IlrDTWTextField_onKeyUp;
  this.doOnKeyUp = IlrDTWTextField_doOnKeyUp;
}


/**
 * capture on keypress events in the text field
 * enter must be captured like this, a validation
 * executes onchange method on the server
 */
function IlrDTWTextField_onKeyPress(e) {
  var input = this.getInput();
  var keyCode;
  if (e)
      keyCode = e.keyCode;
  else
      keyCode = event.keyCode;
  if (keyCode==13){
  	this.keyCode = keyCode;
  	input.blur();
    return false;
  }
  return true;
}
 
 
function IlrDTWTextField_onBlur(event) {
	// do nothing
}
 

/**
 * capture of key up events after the key has been stroked and the text field
 * got its new value
 */
function IlrDTWTextField_onKeyUp(e) {
  var onKeyPressAction = this.onKeyPressAction;
  if (IlxWUtil.instance.isDefined(onKeyPressAction)) {
    var keyCode;
    if (e) {
      keyCode = this.getKeyCode(e);
    } else {
      keyCode = this.getKeyCode(event);
    }
    // move around events should not be notifed to the server
    // 37 = delete
    // 13 = enter
    // 9 = tab
    // 16 = shift+tab 				
    if ((keyCode!=37) && (keyCode != 13) && (keyCode != 9) && (keyCode != 16)){
      var f = new Function(this.getJSRef() + ".doOnKeyUp("+keyCode+");");
      window.setTimeout(f, 1);
      return false;
    }
  }
  return true;
}

/**
 * call back method that is triggered by a key up in the input
 */
function IlrDTWTextField_doOnKeyUp(keyCode){
  var input = this.getInput();
  var onKeyPressAction = this.onKeyPressAction;
  if (IlxWUtil.instance.isDefined(onKeyPressAction)) {
    this.keyCode = keyCode;
    // get the input content after the key has been stroked 
    this.text = input.value;
    this.invalidate(false);
    onKeyPressAction.perform(this, keyCode);
    this.keyCode = -1;
    return false;
  }
  return true;
}