// --------------------------------------------------------------- -- JS --
// IBM Confidential     
// OCO Source Materials  
// 5724-Y00 
//  Copyrights by IBM Corp 1987, 2010. - All rights Reserved
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
// --------------------------------------------------------------------------

function IlrDT_returnObjById(id) 
{ 
	var returnVar;
	if (document.getElementById) 
		returnVar = document.getElementById(id); 
	else if (document.all) 
		returnVar = document.all[id]; 
  else if (document.layers) 
  	returnVar = document.layers[id]; 
  return returnVar; 
 }
 
/////////////////////////////////////////////////////////////////
// recursively look for an element among a node and its children
// elem : the starting node
// tagName :  the tag of the requested element
// exceptTagName : list of tags to ignore
function IlrDT_returnObjByTag(elem, tagName, exceptTagName) 
{ 
	if (!elem) 
		return null;
	if (elem.tagName.toLowerCase() == tagName)
		return elem;
  if (exceptTagName) {
    for (i = exceptTagName.length - 1; i >= 0; i--) {
      if (elem.tagName.toLowerCase() == exceptTagName[i])
			  return null;
    }
  }
	var child = elem.firstChild; 
	while (child) { 
		var res = IlrDT_returnObjByTag(child, tagName, exceptTagName); 
		if (res) 
			return res; 
		child = child.nextSibling; 
	} 
	return null; 
}

/////////////////////////////////////////////////////////////////
// recursively look for an element among a node and its children
// elem : the starting node
// tagNames :  the list of accepted tags for the requested element
// exceptTagName : list of tags to ignore
function IlrDT_returnFirstObjByTags(elem, tagNames, exceptTagName) 
{ 
	if (!elem) 
		return null;
	if (!elem.tagName)
		return null;
	// direct match
	for (i = tagNames.length - 1; i >= 0; i--) {
      	if (elem.tagName.toLowerCase() == tagNames[i])
			return elem;
	}
//  	if (exceptTagName) {
//    	for (i = exceptTagName.length - 1; i >= 0; i--) {
//      		if (elem.tagName.toLowerCase() == exceptTagName[i])
//				return null;
//    	}
//  	}
	var child = elem.firstChild; 
	while (child) { 
		var res = IlrDT_returnFirstObjByTags(child, tagNames, exceptTagName);
		// end of recusion 
		if (res) 
			return res; 
		child = child.nextSibling; 
	} 
	return null; 
}

/**
 * set the focus on the input field when in place editing
 */
function IlrDT_focus(id) 
{ 
	var elem = IlrDT_returnObjByTag(IlrDT_returnObjById(id), 'input', new Array('table', 'select')); 
	if (elem) { 
		elem.focus();
	}
}

/**
 * blur the opened input
 * SD : this is not part of the webui components framework
 * access the input component by iterating through the input of the page
 * should be further refined 
 */
function IlrDT_blurInput(){ 
      var inputs = window.document.getElementsByTagName("input");
      var found = false;
      for (var i = 0; i < inputs.length; i++){
          if (inputs[i].id.search(new RegExp("input")) != -1) {
              inputs[i].blur();
              found = true;
          }
      }
      return found;
  }


