// --------------------------------------------------------------- -- JS --
// IBM Confidential     
// OCO Source Materials  
// 5724-Y00 
//  Copyrights by IBM Corp 1987, 2010. - All rights Reserved
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
// --------------------------------------------------------------------------

function IlrWPopupWindow(port, id, loadCode) {
  this.base = IlxWComponent;
  this.base(port, id);
  this.loadFunction = new Function(this.disableOnload(loadCode)) ;
  this.toggleVisible = IlrWPopupWindow_toggleVisible;
  this.getPosition = IlrWPopupWindow_getPosition;
  this.closeOthers = IlrWPopupWindow_closeOthers;
  this.requestFocusOnFirstTextField = IlrWPopupWindow_requestFocusOnFirstTextField;
  this.forceReload = false;
}

function IlrWPopupWindow_requestFocusOnFirstTextField() {
  var popupWindow = this.port.getElementById(this.path + "theWindow");
  var inputs = popupWindow.getElementsByTagName("input");
  for (var i = 0; i < inputs.length; i++) {
    var input = inputs[i];
    if (input.type == 'text') {
      try {
      input.focus();
      if (input.createTextRange) {
        var r = input.createTextRange();
        r.moveStart('character', input.value.length);
        r.collapse();
        r.select();
      } else {
        //input.select();
      }
        break;
      } catch (exception) {
        // Error when trying to set the focus: do nothing, the textfield is probably not visible.
      }
    }
  }
}

function IlrWPopupWindow_toggleVisible() {
  var ref = this.getJSRef();
  this.disableOnload(ref + ".closeOthers()");
  this.closeOthers();
  var popupWindow = this.port.getElementById(this.path + "theWindow");
  if (popupWindow) {
    if (popupWindow.style.display == "none") {
      if (this.forceReload) {
        if (popupWindow.removeNode) {
          popupWindow.removeNode(true);
        } else {
          popupWindow.parentNode.removeChild(popupWindow);
        }
        eval(this.loadFunction)();
      } else {
        popupWindow.style.display = "inline";
        this.requestFocusOnFirstTextField();
      }
    } else {
      popupWindow.style.display = "none";
    }
  } else {
    eval(this.loadFunction)();
  }
}

function IlrWPopupWindow_closeOthers() {
  var components = this.port.getManager().components;
  for (var cid in components) {
    var otherWindow = components[cid];
    if (otherWindow != this && otherWindow.ctor == "IlrWPopupWindow") {
      var popupWindow = this.port.getElementById(otherWindow.path + "theWindow");
      if (popupWindow) {
        popupWindow.style.display = "none";
      }
    }
  }
}

function IlrWPopupWindow_getPosition(anchorRef) {
  var anchorPosition = this.port.getPosition(anchorRef, this.port.document.body);
  var position = new Object();
  position.left = anchorPosition.left;
  position.top = anchorPosition.top + anchorRef.offsetHeight;
  return position;
}

function static_getElementById(id) {
  if (document.all) {
    return this.document.all[id];
  } else {
    return this.document.getElementById(id);
  }
}