// --------------------------------------------------------------- -- JS --
// IBM Confidential     
// OCO Source Materials  
// 5724-Y00 
//  Copyrights by IBM Corp 1987, 2010. - All rights Reserved
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
// --------------------------------------------------------------------------

// IlrWSyntacticEditor.js
//alert("loading IlrWSyntacticEditor.js..."+window.name);
//debugger;

function IlrWSyntacticEditor(port, id) {
  this.base = IlxWComponent;
  this.base(port, id);
  this.stateToXml = IlrWSyntacticEditor_stateToXml;
  this.resetState = IlrWSyntacticEditor_resetState;
  this.fireTokenAction = IlrWSyntacticEditor_fireTokenAction;
  this.highlightRemovables = IlrWSyntacticEditor_highlightRemovables;
}

function IlrWSyntacticEditor_resetState() {
  this.tokens = new Object();
  this.lines = new Object();
}

/**
 * @deprecated
 */
function IlrWSyntacticEditor_stateToXml() {
  alert("IlrWSyntacticEditor_stateToXml is deprecated");
  var str = "";
  str = IlxWUtil.instance.concat(str, "    <tokens>");
  var tokens = this.tokens;
  for (path in tokens) {
    var action = tokens[path];
    str = IlxWUtil.instance.concat(str, "      <"+action.type+" path=\""+path+"\">");
    if (action.value!="") {
      str = IlxWUtil.instance.concat(str, "        <![CDATA["+action.value+"]]>");
    }
    str = IlxWUtil.instance.concat(str, "      </"+action.type+">");
  }
  str = IlxWUtil.instance.concat(str, "    </tokens>");
  str = IlxWUtil.instance.concat(str, "    <lines>");
  var lines = this.lines;
  for (number in lines) {
    var edit = lines[number];
    str = IlxWUtil.instance.concat(str, "      <line number=\""+number+"\" edit=\""
      +edit+"\"/>");
  }
  str = IlxWUtil.instance.concat(str, "    </lines>");
  return str;
}

function IlrWSyntacticEditor_fireTokenAction(path, name, value) {
  this.tokens[path] = new TokenAction(name, value);
}

function TokenAction(type, value) {
  this.type = type;
  this.value = value;
}

function IlrWSyntacticEditor_highlightRemovables(nodes, on) {
  var l = nodes.length;
  for (var i=0; i<l; i++) {
    var node = this.getPort().getElementById(nodes[i]);
    if (on) {
      var cls = node.className;
      if (""+cls!="undefined") {
        var a = cls.split(" ");
        a[length] = "IlrWHighlightRemovableStyle";
        node.className = a.join(" ");
      } else {
        node.className="IlrWHighlightRemovableStyle";
      }
    } else {
      var cls = node.className;
      if (""+cls!="undefined") {
        var a = cls.split(" ");
        a.length = a.length-1;
      }
      node.className = a.join(" ");
    }
  }
}

// ######################################## OLD ##########################

function displayPopupMenu(node) {
  var token = findEnclosingToken(window.event.srcElement);
  if (token) {
    token = findAbstractMultipleToken(token);
  }
  if (token) {
    selectToken(token, true);
    selectedToken = token;
  } else {
    return false;
  }
  var innerMenu = node.children.menu;
  innerMenu.style.leftPos+=10;
  innerMenu.style.posLeft=event.clientX;
  innerMenu.style.posTop=event.clientY;
  innerMenu.style.display="inline";
  innerMenu.children.table.focus();
  return true;
}

//var selectedToken = false;

function hidePopupMenu(node) {
  var innerMenu = node.children.menu;
  innerMenu.style.display="none";
  if (node.selectedItem=="Delete") {
    alert("delete clicked");
  }
  if (selectedToken) {
    selectToken(selectedToken, false);
    selectedToken = false;
  }
}

function findAbstractMultipleToken(token) {
  var found = false;
  var child = token;
  for (var superToken = getSuperToken(token); 
       superToken;
       superToken = getSuperToken(superToken)) {
    if (superToken.isAbstractMultipleToken) {
      found = true;
      break;
    }
    child = superToken;
  }
  return (found ? child : null);
}

function findEnclosingToken(node) {
  if (!node) {
    return false;
  }
  if (node.isToken) {
    return node;
  } else {
    return findEnclosingToken(node.parentNode);
  }
}

function getSuperToken(token) {
  return findEnclosingToken(token.parentNode);
}

function selectToken(token, select) {
  if (select) {
    // Select the token
    token.style.backgroundColor="highlight";
    token.style.color="white";
  } else {
    token.style.backgroundColor="window";
    token.style.color="black";
  }
}

// end of IlrWSyntacticEditor.js
