// --------------------------------------------------------------- -- JS --
// IBM Confidential     
// OCO Source Materials  
// 5724-Y00 
//  Copyrights by IBM Corp 1987, 2010. - All rights Reserved
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
// --------------------------------------------------------------------------

/************************************************************
 * IlrWValueEditor.
 ************************************************************/

// Constructor

/*@cc_on @*/

function IlrWValueEditor(port, id, onChangeAction,
                         emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass) {
  this.base = IlxWTextField;
  this.base(port, id, onChangeAction,
            emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass);
  this.superOnChange = this.onChange;
/*if (@_jscript_version >= 4)*/ // to restore this for IE: put an arrowbase after the first *
  this.onKeyPress = IlrWValueEditor_onKeyPress;
  this.onChange = IlrWValueEditor_onChange;
/*end */ // to restore this for IE: put an arrowbase after the first * and before the last *
  this.checkInput = IlrWValueEditor_checkInput;
  this.checkValue = IlrWValueEditor_checkValue;
  this.getSelection = IlrWValueEditor_getSelection;
}
//IlrWValueEditor.prototype = new IlxWTextField();

function IlrWValueEditor_getSelection() {
  if (document.selection) {
    return document.selection.createRange().text;
  } else if (document.getSelection) {
    return document.getSelection();
  } else {
    return window.getSelection();
  }
}

function IlrWValueEditor_onKeyPress(e) {
  var input = this.getInput();
  var keyCode;
  if (e) {
    keyCode = this.getKeyCode(e);
  } else {
    keyCode = this.getKeyCode(event);
  }
  if (keyCode==13) {
    input.blur();
    return false;
  }
  if (e && e.which == 0) {
    // On firefox, escape codes (arrow keys, etc.)
    return true;
  }
  if (keyCode == 8) {
    // Backspace
    return true;
  }
  var c = String.fromCharCode(keyCode);
  var selectedLen;
  var caretToEndLen;
  if (document.selection) {
    var r = document.selection.createRange();
    selectedLen = r.text.length;
    caretToEndLen = r.moveStart('character', input.value.length);
  } else if (input.selectionStart || (input.selectionStart == 0)) {
    selectedLen = input.selectionEnd - input.selectionStart;
    caretToEndLen = input.value.length - input.selectionStart;
  }
  var begin = input.value.substring(0,
                                    input.value.length
                                    -caretToEndLen-selectedLen);
  var end = input.value.substring(input.value.length
                                  -caretToEndLen+selectedLen,
                                  input.value.length);
  //alert(begin+" + "+String.fromCharCode(event.keyCode)+" + "+end);
  var s = begin + c + end;
  return this.checkInput(s, e);
}

function IlrWValueEditor_onChange(text) {
  var oldText = this.beginText;
  var input = this.getInput();
  if (!this.checkValue(text)) {
    this.setText(oldText);
    //event.cancelBubble = true;
    event.returnValue = false;
    return false;
    //return this.superOnChange(oldText);
  } else {
    return this.superOnChange(text);
  }
}

function IlrWValueEditor_checkValue(s) {
  return true;
}

function IlrWValueEditor_checkInput(s, e) {
  return true;
}




/************************************************************
 * IlrWStringValueEditor.
 ************************************************************/

function IlrWStringValueEditor(port, id, onChangeAction,
                               emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass) {
  this.base = IlrWValueEditor;
  this.base(port, id, onChangeAction,
            emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass);
  this.formatClass = "java.lang.String";
  this.checkValue = IlrWStringValueEditor_checkValue;
}
//IlrWDoubleValueEditor.prototype = new IlrWValueEditor();

function IlrWStringValueEditor_checkValue(s) {
  return true;
}

/************************************************************
 * IlrWCharacterValueEditor.
 ************************************************************/

function IlrWCharacterValueEditor(port, id, onChangeAction,
                               emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass) {
  this.base = IlrWValueEditor;
  this.base(port, id, onChangeAction,
            emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass);
  this.formatClass = "java.lang.Character";
  this.checkInput = IlrWCharacterValueEditor_checkInput;
  this.checkValue = IlrWCharacterValueEditor_checkValue;
}

function IlrWCharacterValueEditor_checkInput(s, e) {
	/*if (@_jscript_version >= 4)*/
	  var exp = /^.?$/;
	  if (s.match(exp)) {
	    return true;
	  }
	  if (e) {
	    e.returnValue = false;
	  } else {
	    event.returnValue = false;
	  }
	  return false;
	/*   else */
	  return true;
	/*end */
}

function IlrWCharacterValueEditor_checkValue(s) {
  return true;
}

/************************************************************
 * IlrWBooleanValueEditor.
 ************************************************************/

function IlrWBooleanValueEditor(port, id, onChangeAction,
                               emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass) {
  this.base = IlrWValueEditor;
  this.base(port, id, onChangeAction,
            emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass);
  this.formatClass = "java.lang.Boolean";
  this.checkValue = IlrWBooleanValueEditor_checkValue;
}

function IlrWBooleanValueEditor_checkValue(s) {
  return true;
}

/************************************************************
 * IlrWNumberValueEditor.
 ************************************************************/

function IlrWNumberValueEditor(port, id, onChangeAction,
                               emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass) {
  this.base = IlrWValueEditor;
  this.base(port, id, onChangeAction,
            emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass);
  this.checkInput = IlrWNumberValueEditor_checkInput;
  this.checkValue = IlrWNumberValueEditor_checkValue;
  this.checkInputRegExp = IlrWNumberValueEditor_checkInputRegExp;
  this.checkInputAjax = IlrWNumberValueEditor_checkInputAjax;
}

function IlrWNumberValueEditor_checkValue(s) {
  return true;
}

function IlrWNumberValueEditor_checkInput(s, e) {
//  var locale = this.locale;
// Fix for JRULES-11440: removed the   
//  if (locale.indexOf("en_US") == 0) {
//    return this.checkInputRegExp(s, e);
//  } else {
    return this.checkInputAjax(s, e);
//  }
}

function IlrWNumberValueEditor_checkInputRegExp(s, e) {
/*if (@_jscript_version >= 4)*/
  var exp = this.getMatchExpression();
  if (s.match(exp)) {
    return true;
  }
  if (e) {
    e.returnValue = false;
  } else {
    event.returnValue = false;
  }
  return false;
/*   else */
  return true;
/*end */
}

function IlrWNumberValueEditor_checkInputAjax(s, e) {
  var xmlHttpReq;
  var url = this.ajaxURL+"&formatClass="+this.formatClass+"&locale="+this.locale+"&value="+escape(s);
//  var url = "/webresources/servlet/ValueEditorServlet?formatClass="+this.formatClass+"&locale="+this.locale+"&value="+s;
  if (window.XMLHttpRequest) {
    xmlHttpReq = new XMLHttpRequest();
  } else if (window.ActiveXObject) {
    xmlHttpReq = new ActiveXObject("Microsoft.XMLHTTP");
  } else {
    return true;
  }
  xmlHttpReq.open("GET", url, false);
  xmlHttpReq.send("");
  if (xmlHttpReq.responseText.indexOf("true") == 0) {
    return true;
  }
  if (e) {
    e.returnValue = false;
  } else {
    event.returnValue = false;
  }
  return false;
}

/************************************************************
 * IlrWDoubleValueEditor.
 ************************************************************/

function IlrWDoubleValueEditor(port, id, onChangeAction,
                               emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass) {
  this.base = IlrWNumberValueEditor;
  this.base(port, id, onChangeAction,
            emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass);
  this.formatClass = "java.lang.Double";
  this.getMatchExpression = IlrWDoubleValueEditor_getMatchExpression;
}

function IlrWDoubleValueEditor_getMatchExpression() {
/*if (@_jscript_version >= 4)*/
  return /^(-|\+)?(\d+(\.\d*)?((e|E)(-|\+)?\d*)?(d|D)?)?$/;
/*end */
}

/************************************************************
 * IlrWFloatValueEditor.
 ************************************************************/

function IlrWFloatValueEditor(port, id, onChangeAction,
                              emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass) {
  this.base = IlrWNumberValueEditor;
  this.base(port, id, onChangeAction,
            emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass);
  this.formatClass = "java.lang.Float";
  this.getMatchExpression = IlrWFloatValueEditor_getMatchExpression;
}

function IlrWFloatValueEditor_getMatchExpression() {
/*if (@_jscript_version >= 4)*/
  return /^(-|\+)?(\d+(\.\d*)?((e|E)(-|\+)?\d*)?(f|F)?)?$/;
/*end */
}


/************************************************************
 * IlrWIntValueEditor.
 ************************************************************/

function IlrWIntValueEditor(port, id, onChangeAction,
                              emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass) {
  this.base = IlrWNumberValueEditor;
  this.base(port, id, onChangeAction,
            emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass);
  this.formatClass = "java.lang.Integer";
  this.getMatchExpression = IlrWIntValueEditor_getMatchExpression;
}

function IlrWIntValueEditor_getMatchExpression() {
/*if (@_jscript_version >= 4)*/
  return /^(-|\+)?(\d+((e|E)(-|\+)?\d*)?)?$/;
/*end */
}

/************************************************************
 * IlrWByteValueEditor.
 ************************************************************/

function IlrWByteValueEditor(port, id, onChangeAction,
                              emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass) {
  this.base = IlrWNumberValueEditor;
  this.base(port, id, onChangeAction,
            emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass);
  this.formatClass = "java.lang.Byte";
  this.getMatchExpression = IlrWByteValueEditor_getMatchExpression;
}

function IlrWByteValueEditor_getMatchExpression() {
/*if (@_jscript_version >= 4)*/
  return /^(-|\+)?(\d+((e|E)(-|\+)?\d*)?)?$/;
/*end */
}

/************************************************************
 * IlrWShortValueEditor.
 ************************************************************/

function IlrWShortValueEditor(port, id, onChangeAction,
                              emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass) {
  this.base = IlrWNumberValueEditor;
  this.base(port, id, onChangeAction,
            emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass);
  this.formatClass = "java.lang.Short";
  this.getMatchExpression = IlrWShortValueEditor_getMatchExpression;
}

function IlrWShortValueEditor_getMatchExpression() {
/*if (@_jscript_version >= 4)*/
  return /^(-|\+)?(\d+((e|E)(-|\+)?\d*)?)?$/;
/*end */
}

/************************************************************
 * IlrWLongValueEditor.
 ************************************************************/

function IlrWLongValueEditor(port, id, onChangeAction,
                             emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass) {
  this.base = IlrWNumberValueEditor;
  this.base(port, id, onChangeAction,
            emptyText, choices, dhtml, labelId, menuClass, menuItemSelectedClass, menuItemUnSelectedClass);
  this.formatClass = "java.lang.Long";
  this.getMatchExpression = IlrWLongValueEditor_getMatchExpression;
}

function IlrWLongValueEditor_getMatchExpression() {
/*if (@_jscript_version >= 4)*/
  return /^(-|\+)?(\d+((e|E)(-|\+)?\d*)?)?$/;
/*end */
}


