// --------------------------------------------------------------- -- JS --
// IBM Confidential     
// OCO Source Materials  
// 5724-Y00 
//  Copyrights by IBM Corp 1987, 2010. - All rights Reserved
// The source code for this program is not published or otherwise
// divested of its trade secrets, irrespective of what has
// been deposited with the U.S. Copyright Office.
// --------------------------------------------------------------------------


function IlxWSDMView(port, id, servletUrl, x, y, width, height, maxZoomLevel, resizable, interactor,
                     backgroundColor, imageFormat, waitingImage, generateImageMap,
                     jviewsRef) {
  this.base = IlxWView;
  this.base(port, id, servletUrl, x, y, width, height, maxZoomLevel, resizable, interactor,
            backgroundColor, imageFormat, waitingImage, generateImageMap);
  this.jviewsRef = jviewsRef;
  this.showAll = IlxWSDMView_showAll;
  this.showAllImpl = IlxWSDMView_showAllImpl;
  this.zoomIn = IlxWSDMView_zoomIn;
  this.zoomOut = IlxWSDMView_zoomOut;
  this.identity = IlxWSDMView_identity;
  this.identityImpl = IlxWSDMView_identityImpl;
  this.getView = IlxWSDMView_getView;
  this.updateImageSize = IlxWSDMView_updateImageSize;
  this.updateImage = IlxWSDMView_updateImage;
  this.onAfterDeclared = IlxWSDMView_onAfterDeclared;
  this.setVisible = IlxWSDMView_setVisible;
  this.getOffsetParent = IlxWSDMView_getOffsetParent;
  this.initialDisplay = IlxWSDMView_initialDisplay;
  this.toDebugString = IlxWSDMView_toDebugString;
  this.getZoomFactor = IlxWSDMView_getZoomFactor;
  this.updateAll = IlxWSDMView_updateAll;
  this.recenter = IlxWSDMView_recenter;
  this.invalidateImage = IlxWSDMView_invalidateImage;
  this.callShowAllCallback = IlxWSDMView_callShowAllCallback;
  // ##### JVIEWS HACKS!
  this.getView().IlxWSDMView_Component = this;
  // we do not want the recenter method to be applied with pan, zommin, zommout, showall etc.
  // we just want it for our showAll method
  this.getView().saveRecenter = this.getView().recenter;
  this.getView().recenter = function () {}
  this._showAllCallback = function() {}
  this.getView().showAll = function() {
    this.IlxWSDMView_Component.callShowAllCallback();
  }
  setTimeout(this.getJSRef()+".initialDisplay()", 10);
}

function IlxWSDMView_onAfterDeclared() {
  // need only to center the animated gif...
  // the "real initialDisplay is made by the timer.
  this.initialDisplay();
}

function IlxWSDMView_getOffsetParent() {
  var span = this.port.getElementById("IlxWSDMView_"+this.path);
  if (span) {
    return span.offsetParent;
  }
}

function IlxWSDMView_setVisible(visible) {
  var theView = this.getView();
}

function IlxWSDMView_updateImage() {
  var theView = this.getView();
  theView.updateImage();
}

function IlxWSDMView_updateAll(showAll, keepLayerVisibility) {
  var theView = this.getView();
  theView.updateAll(showAll, keepLayerVisibility);
}


function IlxWSDMView_updateImageSize() {
  var theView = this.getView();
  var offsetParent = this.getOffsetParent();
  if (offsetParent) {
    var parentWidth = offsetParent.offsetWidth; //document.body.clientWidth;
    var parentHeight = offsetParent.offsetHeight; //document.body.clientHeight;
    theView.width = parentWidth;
    theView.height = parentHeight;

    var oldBounds = theView.imagePanel.getBounds();
    var bbox = theView.getViewBBox();
    var zoomFactor = this.getZoomFactor();
    //alert(zoomFactor.x+" : "+zoomFactor.y);

    var dw = (parentWidth - oldBounds.width) / zoomFactor.x;
    var dh = (parentHeight - oldBounds.height) / zoomFactor.y;
    var pos = window.IlxWPortI.getPosition(offsetParent, document.body);
    theView.qbboxw = theView.qbboxw + dw;
    theView.qbboxh = theView.qbboxh + dh;
    theView.imagePanel.setLocation(pos.left, pos.top);
    theView.imagePanel.setSize(parentWidth, parentHeight);
    theView.eventPanel.setLocation(pos.left, pos.top);
    theView.eventPanel.setSize(parentWidth, parentHeight);
  } else {
    theView.imagePanel.setLocation(150, 50);
    theView.imagePanel.setSize(300, 300);
    theView.width = 300;
    theView.height = 300;
  }
}

function IlxWSDMView_getZoomFactor() {
  var theView = this.getView();
  var bbox = theView.getViewBBox();
  var zoomFactorX = theView.imagePanel.width / bbox.width;
  var zoomFactorY = theView.imagePanel.height / bbox.height;
  var result = new Object();
  result.x = zoomFactorX;
  result.y = zoomFactorY;
  return result;
}

function IlxWSDMView_recenter() {
  var theView = this.getView();
  if (theView.getHeight() ==0 || theView.getWidth() ==0)
    return;

  var ratio = theView.getWidth()/theView.getHeight();
  var a = (theView.maxx - theView.minx)/theView.qbboxw;
  var b = ((theView.maxy - theView.miny)/theView.qbboxh);
  var  zooml = a > b? a: b;
  if (theView.qbboxw < theView.qbboxh *ratio) {
    var dif = theView.qbboxw - theView.qbboxh*ratio;
    theView.qbboxw = theView.qbboxh*ratio;
    theView.qbboxx += dif/2;
  } else {
    var dif = theView.qbboxh - theView.qbboxw/ratio;
    theView.qbboxh = theView.qbboxw/ratio;
    theView.qbboxy += dif/2;
  }
}


function IlxWSDMView_callShowAllCallback() {
  this._showAllCallback();
}

function IlxWSDMView_showAllImpl() {
  var theView = this.getView();
  this.updateImageSize();
  theView.qbboxx = theView.minx;
  theView.qbboxy = theView.miny;
  theView.qbboxw = theView.maxx - theView.minx;
  theView.qbboxh = theView.maxy - theView.miny;
  this.recenter();
  this.updateImage();
}

function IlxWSDMView_showAll() {
  this._showAllCallback = IlxWSDMView_showAllImpl;
  this.updateAll(true, false);
}

function IlxWSDMView_initialDisplay() {
  var theView = this.getView();
  this.updateImageSize();
  if (((theView.maxx - theView.minx) < theView.imagePanel.width)
      && ((theView.maxy - theView.miny) < theView.imagePanel.height)) {
    this.identity();
  } else {
    this.showAll();
  }
}

function IlxWSDMView_identity() {
  this._showAllCallback = IlxWSDMView_identityImpl;
  this.updateAll(true, false);
}

function IlxWSDMView_identityImpl() {
  var theView = this.getView();
  this.updateImageSize();
  theView.setViewBBox(theView.minx - (theView.width/2 - (theView.maxx-theView.minx)/2),
                      theView.miny - (theView.height/2 - (theView.maxy-theView.miny)/2),
                      theView.width,
                      theView.height);
//  alert(this.toDebugString(this.getView()));
}

function IlxWSDMView_zoomIn() {
  this.updateImageSize();
  this.getView().zoomIn();
}

function IlxWSDMView_zoomOut() {
  this.updateImageSize();
  this.getView().zoomOut();
}

function IlxWSDMView_invalidateImage(updateCapabilities) {
  this.updateImageSize();
  if (updateCapabilities) {
    this.updateAll(true,false);
  } else {
    this.updateImage();
  }
}

function IlxWSDMView_toDebugString() {
  var theView = this.getView();
  return "minx: " + theView.minx + "\n"
       + "miny: " + theView.miny + "\n"
       + "maxx-minx: " + (theView.maxx - theView.minx) + "\n"
       + "maxy-miny: " + (theView.maxy - theView.miny) + "\n"
       + "\n"
       + "qbboxx: " + theView.qbboxx + "\n"
       + "qbboxy: " + theView.qbboxy + "\n"
       + "qbboxw: " + theView.qbboxw + "\n"
       + "qbboxh: " + theView.qbboxh + "\n"
       + "\n"
       + "width: " + theView.width + "\n"
       + "height: " + theView.height + "\n"
       + "\n"
       + "imagePanel.width: " + theView.imagePanel.width + "\n"
       + "imagePanel.height: " + theView.imagePanel.height + "\n"
       ;
}

function IlxWSDMView_getView() {
  return window[this.jviewsRef];
}
